/*------------------------------------------------------------------------------
--  This file is a part of the libuc, microcontroler library
--  Copyright (C) 2011, Alexis Jeandet
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
-------------------------------------------------------------------------------
--                 Author : Alexis Jeandet
--                   Mail : alexis.jeandet@gmail.com
-------------------------------------------------------------------------------*/
#ifndef UART_H
#define UART_H

#include <stm32f4xx.h>
#include <uhandle.h>
#include <stdint.h>

#define uartNoParity 0
#define uartOddParity 1
#define uartEvenParity 3
#define uartTrueParity 5
#define uartFalseParity 7

//typedef struct
//{
//  __IO uint16_t SR;         /*!< USART Status register,                   Address offset: 0x00 */
//  uint16_t      RESERVED0;  /*!< Reserved, 0x02                                                */
//  __IO uint16_t DR;         /*!< USART Data register,                     Address offset: 0x04 */
//  uint16_t      RESERVED1;  /*!< Reserved, 0x06                                                */
//  __IO uint16_t BRR;        /*!< USART Baud rate register,                Address offset: 0x08 */
//  uint16_t      RESERVED2;  /*!< Reserved, 0x0A                                                */
//  __IO uint16_t CR1;        /*!< USART Control register 1,                Address offset: 0x0C */
//  uint16_t      RESERVED3;  /*!< Reserved, 0x0E                                                */
//  __IO uint16_t CR2;        /*!< USART Control register 2,                Address offset: 0x10 */
//  uint16_t      RESERVED4;  /*!< Reserved, 0x12                                                */
//  __IO uint16_t CR3;        /*!< USART Control register 3,                Address offset: 0x14 */
//  uint16_t      RESERVED5;  /*!< Reserved, 0x16                                                */
//  __IO uint16_t GTPR;       /*!< USART Guard time and prescaler register, Address offset: 0x18 */
//  uint16_t      RESERVED6;  /*!< Reserved, 0x1A                                                */
//} USART_TypeDef;

typedef volatile struct USART_TypeDef* _uartDev;
typedef UHANDLE uartDev;

extern uartDev uartopen(int count);
extern void uarton(int count);
extern void uartoff(int count);
extern void uartputc(uartDev dev,char c);
extern void uartputs(uartDev dev,char *s);
extern void uartgets(uartDev dev,char *s);
extern char uartgetc(uartDev dev);
extern void uartsetbaudrate(uartDev dev,unsigned int  baudRate);
extern unsigned char uartgetpclkfactor(uartDev dev);
extern void uartsetpclkfactor(uartDev dev,unsigned char pclkfactor);
extern void uartsetup(uartDev dev,unsigned int  baudRate,unsigned char WordLength,unsigned char StopBitCnt,unsigned char Parity);

#endif








